exercise_03_14: exercise_03_14.o Employee.o | .gitignore
	g++ $^ -o $@ 

Employee.ii: Employee.cpp
	g++ -E $^ -o $@

Employee.s: Employee.ii
	g++ -S $^ -o $@

Employee.o: Employee.s
	g++ -c $^ -o $@
        
exercise_03_14.ii: exercise_03_14.cpp
	g++ -E $^ -o $@

exercise_03_14.s: exercise_03_14.ii
	g++ -S $^ -o $@

exercise_03_14.o: exercise_03_14.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_03_14" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_03_14 .gitignore debug

test: exercise_03_14 
	./exercise_03_14 > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_03_14.ii exercise_03_14.s Employee.ii Employee.s
.SECONDARY: exercise_03_14.ii exercise_03_14.s Employee.ii Employee.s

dbg: debug/exercise_03_14 

debug/exercise_03_14: debug/exercise_03_14.o Employee.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/Employee.o: Employee.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/Employee.s: Employee.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/Employee.ii: Employee.cpp
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_03_14.o: debug/exercise_03_14.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_03_14.s: debug/exercise_03_14.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_03_14.ii: exercise_03_14.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

